import numpy as np

# Importez les  fonctions 
from mlp import  train_mlp, accuracy

def test_mlp_training():
    # Paramètres du test
    num_samples = 200
    num_features = 10
    num_classes = 3
    num_hidden_units = 5
    learning_rate = 0.1
    num_epochs = 10
    d_in= 3
    d_out=2
    d_h=3

    # Générez des données factices pour le test
    X_train = np.random.randn(num_samples, num_features)
    y_train = np.random.randint(0, num_classes, num_samples)
    X_test = np.random.randn(num_samples, num_features)
    y_test = np.random.randint(0, num_classes, num_samples)

    # Initialisez les poids et les biais
    w1 = 2 * np.random.rand(d_in, d_h) - 1  # First layer weights
    b1 = np.zeros((1, d_h))  # First layer biases
    w2 = 2 * np.random.rand(d_h, d_out) - 1  # Second layer weights
    b2 = np.zeros((1, d_out))  # Second layer biases

    # Entraînez le modèle
    train_accuracies, test_accuracy = train_mlp(w1, b1, w2, b2, X_train, y_train, learning_rate, num_epochs)

    # Vérifiez si l'accuracy est un nombre entre 0 et 1
    assert 0 <= test_accuracy <= 1

    # Vérifiez si la longueur de la liste des accuracies d'entraînement correspond au nombre d'époques
    assert len(train_accuracies) == num_epochs

    # Vérifiez si les accuracies d'entraînement sont des nombres entre 0 et 1
    for accuracy in train_accuracies:
        assert 0 <= accuracy <= 1

    print("Tous les tests ont réussi avec succès.")


